<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | 48.10</title>

  <!-- DataTable-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- daterange picker -->
  <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
  <!-- iCheck for checkboxes and radio inputs -->
  <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css">
  <!-- Bootstrap Color Picker -->
  <link rel="stylesheet" href="plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- Bootstrap4 Duallistbox -->
  <link rel="stylesheet" href="plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">
  <!-- BS Stepper -->
  <link rel="stylesheet" href="plugins/bs-stepper/css/bs-stepper.min.css">
  <!-- dropzonejs -->
  <link rel="stylesheet" href="plugins/dropzone/min/dropzone.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Toastr -->
  <link rel="stylesheet" href="plugins/toastr/toastr.min.css">



</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-purple navbar-dark">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Users</a>
        </li>
      </ul>


    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-indigo bg-gray-dark elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Devcamp 120</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/avatar4.png" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">QuanNM</a>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="index.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Quản lý bảng điểm</p>
                  </a>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Quản lý đơn hàng</p>
                  </a>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <section class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1>Quản lý bảng điểm</h1>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Quản lý bảng điểm</li>
              </ol>
            </div>
          </div>
        </div><!-- /.container-fluid -->
      </section>

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div class="row text-center my-3">
            <div class="col-sm-12">
              <h3>LỊCH SỬ HỌC TẬP</h3>
            </div>
          </div>
          <div class="row ">
            <div class="col-sm-12">
              <button id="btn-add" class="btn btn-success h4 font-weight-bold"><i class="fas fa-plus"
                  style="font-size: 12px;"></i>
                Thêm</button>
            </div>
          </div>
          <div class="row text-center">
            <div class="col-sm-12">
              <table class="table table-bordered table-striped table-hover" id="table-history">
                <thead class="thead-dark">
                  <tr>
                    <th>STT</th>
                    <th>Sinh viên</th>
                    <th>Môn học</th>
                    <th>Điểm</th>
                    <th>Ngày thi</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                </tbody>
              </table>
            </div>
          </div>


        </div>

        <!-- Modal create new data-->
        <div class="modal fade" id="modal-create">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header bg-gradient-success ">
                <h4 class="modal-title">Thêm mới</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="row">
                  <div class="col-sm-12">
                    <div class="form-group">
                      <label>Tên người dùng:</label>
                      <select id="select-add-username" class="form-control select2bs4" style="width: 100%;">
                      </select>
                    </div>
                    <div class="form-group">
                      <label>Môn học:</label>
                      <select id="select-add-subject" class="form-control select2bs4" style="width: 100%;">
                      </select>
                    </div>
                    <div class="form-group">
                      <label>Điểm:</label>
                      <input type="number" class="form-control select2bs4" name="" id="inp-add-grade"
                        placeholder="Nhập điểm số...">
                    </div>
                    <div class="form-group">
                      <label>Ngày thi:</label>
                      <div class="input-group">
                        <div class="input-group-prepend">
                          <span class="input-group-text"><i class="far fa-calendar-alt"></i></span>
                        </div>
                        <input id="inp-add-exam-date" class="form-control" data-inputmask-alias="datetime"
                          data-inputmask-inputformat="dd/mm/yyyy" data-mask>
                      </div>
                      <!-- /.input group -->
                    </div>
                  </div>
                </div>
              </div>
              <div class="modal-footer justify-content-between">
                <button type="button" class="btn btn-default" data-dismiss="modal">Hủy</button>
                <button type="button" class="btn btn-success">Tạo mới</button>
              </div>
            </div>
            <!-- /.modal-content -->
          </div>
          <!-- /.modal-dialog -->
        </div>
        <!-- /.modal -->
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
    </footer>

  </div>
  <!-- ./wrapper -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- Select2 -->
  <script src="plugins/select2/js/select2.full.min.js"></script>
  <!-- Bootstrap4 Duallistbox -->
  <script src="plugins/bootstrap4-duallistbox/jquery.bootstrap-duallistbox.min.js"></script>
  <!-- InputMask -->
  <script src="plugins/moment/moment.min.js"></script>
  <script src="plugins/inputmask/jquery.inputmask.min.js"></script>
  <!-- date-range-picker -->
  <script src="plugins/daterangepicker/daterangepicker.js"></script>
  <!-- bootstrap color picker -->
  <script src="plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js"></script>
  <!-- Tempusdominus Bootstrap 4 -->
  <script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
  <!-- BS-Stepper -->
  <script src="plugins/bs-stepper/js/bs-stepper.min.js"></script>
  <!-- dropzonejs -->
  <script src="plugins/dropzone/min/dropzone.min.js"></script>
  <!-- Toastr -->
  <script src="plugins/toastr/toastr.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="dist/js/demo.js"></script>
  <!-- Page specific script -->

  <script>
    $(function () {

      //Initialize Select2 Elements
      $('.select2').select2();
      //Datemask dd/mm/yyyy
      $('#inp-add-exam-date').inputmask('dd/mm/yyyy', {
        'placeholder': 'dd/mm/yyyy'
      });
    });
  </script>


  <script>
    'use strict';
    const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
    var gListStudent;
    var gListSubjects;
    var gListGrades;
    var gHistory = [];
    var gSTT = 0;
    const gHISTORY_COLS = ["stt", "studentName", "subjectName", "grade", "examDate", "action"];

    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gHISTORY_STT_COL = 0;
    const gHISTORY_STUDENT_NAME_COL = 1;
    const gHISTORY_SUBJECT_NAME_COL = 2;
    const gHISTORY_GRADE_COL = 3;
    const gHISTORY_EXAM_DATE_COL = 4;
    const gHISTORY_ACTION_COL = 5;
    var gHistoryTable = $("#table-history").DataTable({
      columns: [{
          data: gHISTORY_COLS[gHISTORY_STT_COL]
        },
        {
          data: gHISTORY_COLS[gHISTORY_STUDENT_NAME_COL]
        },
        {
          data: gHISTORY_COLS[gHISTORY_SUBJECT_NAME_COL]
        },
        {
          data: gHISTORY_COLS[gHISTORY_GRADE_COL]
        },
        {
          data: gHISTORY_COLS[gHISTORY_EXAM_DATE_COL]
        },
        {
          data: gHISTORY_COLS[gHISTORY_ACTION_COL]
        }
      ],
      columnDefs: [{
          targets: gHISTORY_STT_COL,
          render: function (data) {
            gSTT++;
            return gSTT;
          }
        },
        {
          targets: gHISTORY_ACTION_COL,
          defaultContent: "<button class='btn btn-primary user-detail'>Chi tiết</button>"
        }
      ]
    });
    onPageLoading();

    // xử lý btn
    $(document).ready(function () {
      // btn thêm clicked
      $('#btn-add').on('click', function () {
        $('#modal-create').modal('show');
        loadDataUserNameToSelect();
        loadDataSubjectsToSelect();
      });
      // btn Tạo clicked
      $('#modal-create').on('click', '.btn-success', onBtnCreateClick);


    })
    //Hàm btn Tạo clicked
    function onBtnCreateClick() {
      'use strict';
      var vNewDataObj = {
        studentId: '',
        subjectId: '',
        grade: '',
        examDate: ''
      }
      getDataFromModalAdd(vNewDataObj);

      var vValidData = validateNewDataObj(vNewDataObj);
      if (vValidData) {
        $.ajax({
          url: gBASE_URL + "/grades",
          type: 'POST',
          data: JSON.stringify(vNewDataObj),
          contentType: "application/json; charset=utf-8",
          success: function (res) {
            toastr.success('Tạo mới thành công');
            callApiListGrades();
            dataHistoryObj();
            loadDataToTable(gHistory);
            $('#modal-create').modal('hide');
          },
          error: function () {
            toastr.error('Tạo mới không thành công');
          }
        })
      }
    }
    //Load trang
    function onPageLoading() {
      'use strict';
      // danh sách sinh viên
      $.ajax({
        async: false,
        url: gBASE_URL + "/students",
        type: 'GET',
        data: 'json',
        success: function (res) {
          gListStudent = res;
          console.log("%c danh sách sinh viên", "color:red");
          console.log(gListStudent);
        },
        error: function (data) {
          alert(data.responseText)
        }
      });
      // danh sách môn học
      $.ajax({
        async: false,
        url: gBASE_URL + "/subjects",
        type: 'GET',
        data: 'json',
        success: function (res) {
          gListSubjects = res;
          console.log("%c danh sách môn học", "color:red");
          console.log(gListSubjects);
        },
        error: function (data) {
          alert(data.responseText)
        }
      });
      // danh sách lịch sử học tập
      callApiListGrades();
      // Tổng hợp dữ liệu
      dataHistoryObj();
      loadDataToTable(gHistory);
    }

    function callApiListGrades() {
      'use strict';
      $.ajax({
        async: false,
        url: gBASE_URL + "/grades",
        type: 'GET',
        data: 'json',
        success: function (res) {
          gListGrades = res;
          console.log("%c danh sách điểm", "color:red");
          console.log(gListGrades);
        },
        error: function (data) {
          alert(data.responseText)
        }
      });
    }

    function dataHistoryObj() {
      'use strict';
      $.each(gListGrades, function (key, val) {
        for (let bI = 0; bI < gListStudent.length; bI++) {
          if (val.studentId == gListStudent[bI].id) {
            val.studentName = gListStudent[bI].lastname + " " + gListStudent[bI].firstname;
          }
        }
        for (let bI = 0; bI < gListSubjects.length; bI++) {
          if (val.studentId == gListSubjects[bI].id) {
            val.subjectName = gListSubjects[bI].subjectName;
            gHistory.push(val);
          }
        }
      });
    }

    function loadDataToTable(paramDataHistory) {
      'use strict';
      gHistoryTable.clear();
      gHistoryTable.rows.add(paramDataHistory);
      gHistoryTable.draw();
    }

    function loadDataUserNameToSelect() {
      'use strict';
      $('#select-add-username').empty();
      $('<option/>').val('').text('Chọn username').appendTo('#select-add-username');
      $.each(gListStudent, function (key, val) {
        $('<option/>').val(val.id).text(val.username).appendTo('#select-add-username');
      })
    }

    function loadDataSubjectsToSelect() {
      'use strict';
      $('#select-add-subject').empty();
      $('<option/>').val('').text('Chọn môn học').appendTo('#select-add-subject');
      $.each(gListSubjects, function (key, val) {
        $('<option/>').val(val.id).text(val.subjectName).appendTo('#select-add-subject');
      })
    }

    function getDataFromModalAdd(paramNewDataObj) {
      'use strict';
      paramNewDataObj.studentId = $('#select-add-username').val();
      paramNewDataObj.subjectId = $('#select-add-subject').val();
      paramNewDataObj.grade = $('#inp-add-grade').val();
      paramNewDataObj.examDate = $('#inp-add-exam-date').val();
    }

    function validateNewDataObj(paramNewDataObj) {
      'use strict';
      var parts = paramNewDataObj.examDate.split("/");
      var year = parseInt(parts[2], 10);
      if (paramNewDataObj.studentId == '') {
        toastr.error('Hãy chọn Use Name');
        return false;
      }
      if (paramNewDataObj.subjectId == '') {
        toastr.error('Hãy chọn Môn học');
        return false;
      }
      if (paramNewDataObj.grade == '' || paramNewDataObj.grade > 10 || paramNewDataObj.grade < 0) {
        toastr.error('Hãy nhập điểm (trong khoảng 0 đến 10)');
        return false;
      }
      if (paramNewDataObj.examDate == '') {
        toastr.error('Hãy nhập ngày thi');
        return false;
      }
      if (year < 2000 || year > 2022) {
        toastr.error('Ngày thi không hợp lệ (năm trong khoảng 2000 đến 2022)');
        return false;
      }
      return true;
    }
  </script>
</body>

</html>
